<template>
    <div class="product">        
        <img class="image" :src="image" />
        <h3 class="name">{{item.name | uppercase }}</h3>
        <div class="description" v-if='item.description.length > 0'>{{item.description | lowercase}}</div> 
        <app-product-param v-if='item.sizes.length > 0' :values='item.sizes' :valuesToShow='item.sizes' @change='changeSizes({id: item.id, values: arguments[0]})' />
        <app-product-param v-if='item.thickness.length > 0' :values='item.thickness' :valuesToShow='filteredThickness' @change='changeThickness({id: item.id, values: arguments[0]})' />
        <app-product-param v-if='item.sauces.length > 0' :values='item.sauces' :valuesToShow='item.sauces' @change='changeSauces({id: item.id, values: arguments[0]})' />
        <app-product-cta :item="item" />
    </div>
</template>

<script>
    import ProductCTA from './ProductCTA';
    import ProductParam from './ProductParam';
    import { mapMutations } from 'vuex';
    const imagesContext = require.context('../assets', true) 
    export default {
        components: {
            'app-product-cta': ProductCTA,
            'app-product-param': ProductParam,
        },
        props: ['item'],
        data() {
            return {
                images: imagesContext, 
            }
        },
        methods: {
            ...mapMutations([
                'changeSizes',
                'changeThickness',
                'changeSauces',
            ])
        },
        computed: {
            filteredThickness() {
                const s25 = this.item.sizes.find(it => it.id === 25); 
                if (s25 && s25.selected == true) {
                    return [this.item.thickness[0]];
                } else {
                    return this.item.thickness;
                }
            },
            image() {                                
                if (this.item.sizes.length > 0) {
                    const size = this.item.sizes.find(it => it.selected == true);  
                    const thickness = this.item.thickness.find(it => it.selected == true);                                       
                    try {                        
                        return this.images(`./${this.item.image}-${size.id.toString()}-${thickness.id}.png`);
                    } catch(err) {
                        try {
                            return this.images(`./${this.item.image}-${thickness.id}.png`);
                        } catch(err) {
                            try {
                                return this.images(`./${this.item.image}.png`);
                            } catch(err) {
                                return this.images('./noimage.svg');
                            }
                        }                    
                    }              
                } else {                        
                    try {
                        return this.images(`./${this.item.image}.png`);
                    } catch(err) {                
                        return this.images('./noimage.svg');
                    }
                }              
            }
        }
    }
</script>

<style scoped>

    .product {            
        display: flex;    
        flex-flow: column nowrap;        
        align-items: center;    
        margin: 50px 20px 50px 20px;        
        width: 350px;
    }

    .image {        
        width: 300px;
        /* height: 300px;         */
        padding: 5px;                
        background-image: url('../assets/noimage.svg') no-repeat;
        background-size: cover;
        
    }

    .name {
        flex: 1;
        font-size: 1.3em;
        padding-top: 10px;
        padding-bottom: 10px;        
        font-weight: normal;
    }

    .description {
        flex: 1;
        color: #777;        
        margin-bottom: 20px;        
    }

</style>

